#include "gui.h"

extern WINDOW *winReception;
extern WINDOW *winTransmission;
int xMaxR, yMaxR, xMaxT, yMaxT;

///////////////////////////Methodes pour reception///////////////////////////
//Initialiser la fenetre Reception
void iniGUI_Reception()
{
	getmaxyx(stdscr,yMaxR,xMaxR);
	winReception = newwin((yMaxR/2),xMaxR,0,0);
	printf("%d", yMaxR);
	scrollok(winReception, true);
	mvwprintw(winReception,1,(xMaxR/2)-4,"RECEPTION");
}

//Faire afficher du texte dans Reception
void afficherTexte(char* texte)
{
	mvwprintw(winReception,3,1,"%s",texte);
}

//Enlever le texte dans la fenetre reception
void clearTexteReception()
{
	wmove(winReception,2,1);
	for(int i = 2; i < yMaxT - 2 * 2; i++)
	{
		wmove(winReception, i, 0);
		whline(winReception, ' ', xMaxR - 1 * 2);
	}
}

///////////////////////////Methodes pour transmission///////////////////////////
//Initialiser la fenetre Transmission
void iniGUI_Transmission()
{

	getmaxyx(stdscr,yMaxT,xMaxT);
	winTransmission = newwin(15,xMaxT,(yMaxT/2)+1,0);
	//box(winTransmission,0,0);
	mvwprintw(winTransmission,1,(xMaxT/2)-6,"TRANSMISSION");
	mvwprintw(winTransmission,2,1,"h/H:help | q/Q:quit");
	mvwprintw(winTransmission,3,1,"Que voulez-faire?");
}

//Enlever le texte de la position 4,1 jusqau bordure
void clearTexteTransmission()
{
	wmove(winTransmission,4,1);
	for(int i = 4; i < yMaxT/2 - 2; i++)
	{
		wmove(winTransmission, i, 1);
		whline(winTransmission, ' ', xMaxT - 1 * 2);
	}
}

//Enlever le input de la position 3,19 jusqua la bordure
void clearInput()
{
	wmove(winTransmission, 3, 19);
	whline(winTransmission, ' ', xMaxT - 19 * 2);
}

