#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <semaphore.h>
#include <pthread.h>
#include <curses.h>
#include <ctype.h>

#include <stdint.h>
#include <signal.h>
/* unix */
#include <unistd.h>
#include <fcntl.h>

#include <sys/time.h>
#include <sys/types.h>
#include <sys/termios.h>
#include <sys/mman.h>
#include <sys/stat.h>

#define SERVER_FIFO_NAME "./tmp/FIFO_TRANSACTIONS"
#define CLIENT_FIFO_NAME "../Client/tmp/FIFO%d"

struct infoVM {						
	int noVM;
	unsigned char busy; 
	uint16_t * ptrDebutVM;	
	uint16_t  offsetDebutCode; // region memoire ReadOnly
	uint16_t  offsetFinCode;
};								 

struct noeudVM {			
	struct infoVM VM;		
	struct noeudVM * suivant;
	sem_t semVM;
};

struct paramX {
	int noVM;
	char nomfich[100];
};

struct ListItemsArgs {
    int start;
    int end;
};

struct Info_FIFO_Transaction {
	int pid_client;
	char transaction[399];
};

void cls(void);
void error(const int exitcode, const char * message);

struct noeudVM * findItem(const int no);
struct noeudVM * findPrev(const int no);

void init_TPP();
void addItem();
void removeItem(const int noVM);
void listItems(struct ListItemsArgs* args);
void saveItems(const char* sourcefname);
void executeFile(struct paramX* param);
void sendMessageToClient(char* message);

void* readTrans(void* arg);
