#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <semaphore.h>
#include <pthread.h>

#include <stdint.h>
#include <signal.h>
/* unix */
#include <unistd.h>
#include <fcntl.h>

#include <sys/time.h>
#include <sys/types.h>
#include <sys/termios.h>
#include <sys/mman.h>

struct infoVM{						
	int		noVM;//le numero de vm
	unsigned char 	busy; //active ou pas?
	uint16_t * 	ptrDebutVM;	//pointeur de debut(sachant que uint est un unsigned number stored sur 16bits
					//donc sa maxValue est 65536, selon interneth
	uint16_t   	offsetDebutCode; // region memoire ReadOnly
	uint16_t   	offsetFinCode;
	};								 

struct noeudVM{			
	struct infoVM	VM;		
	struct noeudVM		*suivant;	
	sem_t semVM;//Donc on peut bloquer l'acces a un noeud specifique, le temps de faire une action, par exemple
	};	

struct paramX
{
	int noVM;//numero de la machine virtuelle
	char nomfich[100];//nom du fichier binaire a executer
	char * dataPtr;//*-*-*-*-*-*-*-*-*-*-*-*-**-*-
};		

struct Struct_REMOVE
{						
	int noVM;
	char * dataPtr;//*-*-*-*-*-*-*-*-*-*-*-*-**-*-
};

struct Struct_Listage
{						
	int start;
	int end;
	char * dataPtr;//*-*-*-*-*-*-*-*-*-*-*-*-**-*-
};

void cls(void);
void error(const int exitcode, const char * message);

struct noeudVM * findItem(const int no);
struct noeudVM * findPrev(const int no);

void addItem(void * ptr);
void removeItem(struct Struct_REMOVE* param);
void listItems(struct Struct_Listage* param);
void saveItems(const char* sourcefname);

//la structure paramX pour le passage des parametres au thread executeFile()
void executeFile(struct paramX* param);

void* readTrans(char* nomFichier);
int extract(char *ptr);//*-*-*-*-*-*-*-*-*-*-*-*-**-*-
