#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <limits.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <ncurses.h>
#include <ctype.h>

// Chemin vers le FIFO pour les transactions
#define FIFO_TRANSACTIONS "./tmp/serv_fifo"

// Modifiez le format du nom du FIFO client en ajoutant un commentaire
#define CLIENT_FIFO_NAME "./tmp/cli_%d_fifo"  // Le %d correspond au PID pour la communication

#define BUFFER_SIZE 400

// Structure de transmission d'information par FIFO srialise avec un buffer de 400
struct Info_FIFO_Transaction {
    pid_t pid_client;
    char transaction[BUFFER_SIZE - 1];
};

