Install make :
    sudo apt install make

Create the C library :
    if not in client folder change directory to client
        cd client
    make

Install conda :
    wget https://repo.anaconda.com/archive/Anaconda3-2021.05-Linux-x86_64.sh
    bash Anaconda3-2021.05-Linux-x86_64.sh

Create a conda environment :
    conda create -n tp2 python=3.11

Deactivate if open on an conda environment :
    conda deactivate

Activate the conda environment :
    conda activate tp2

Install the required packages :
    pip install -r requirements.txt

Convert the python script to an executable and include the C library: 
    pyinstaller --onefile --add-binary "./libclient.so:." gui2.py

Make the gui2 executable :
    cd dist
    chmod +x gui2

Move the executable to the client folder :
    mv gui2 ../

Run the executable :
    ./gui2
