//#########################################################
//#
//# Titre : 	        TP1
//# Auteur : 	        Simon Lavgine 
//# Auteur original : 	Francois Meunier
//#	Date :		        10-31-2023
//#
//#######################################

#include "gestionListeChaineeVMS.h"
#include "gestionVMS.h"
#include <pthread.h>

//Pointeur de tête de liste
struct noeud* head;
//Pointeur de queue de liste pour ajout rapide
struct noeud* queue;
// nombre de VM actives
int nbVM;
//nombre operation
int nbOper;
//Création des mutex pour l'ensemble des ressources partagées
pthread_mutex_t mutexHead, mutexQueue, mutexnbVM, mutexConsole, mutexnbOper , mutexFile;

//Creation of named pipe 'Name' to pass to the other function that will instanciate the Named pipe.
char * fifoName = "./FIFO_TRANSACTION";

int main(int argc, char* argv[]){

	//Initialisation des pointeurs et mutex
	head = NULL;
	queue = NULL;
	nbVM = 0;
	nbOper = 0;
	
	pthread_mutex_init(&mutexHead, NULL);	
	pthread_mutex_init(&mutexQueue, NULL);
	pthread_mutex_init(&mutexnbVM, NULL);	
	pthread_mutex_init(&mutexConsole, NULL);
	pthread_mutex_init(&mutexnbOper, NULL);
	pthread_mutex_init(&mutexFile, NULL);
	
	cls();
	readTrans(fifoName);
	exit( 0);
	
}

