//#########################################################
//# NOM:
//# Papa Sidy Chimère Diaw
//#	Mariama Niang	
//#	Elvire Mputu
//# Emile Wamba


#include "gestionListeChaineeVMS.h"
#include "gestionVMS.h"


//Pointeur de tête de liste
struct noeudVM* head;
//Pointeur de queue de liste pour ajout rapide
struct noeudVM* queue;
// nombre de VM actives
int nbVM;
//nombre de trhreads actifs
int nbThreadAELX;
//Semaphores
sem_t semH, semQ, semnbVM, semConsole, semnbThreadAELX, semAdd, semRemove, semListPtr, semExecutePtr;

/*Pointeurs globaux pour recuperation d'affichage dans les fonctions : 
addItem(), removeItem(), listItem(), executeFile();*/
char* addPtr;
char* removePtr;
char* listPtr;
char* executePtr;




int main(int argc, char* argv[])
{
	//Initialisation des pointeurs
	head = NULL;
	queue = NULL;
	//listPtr = NULL;
	//executePtr = NULL;
	nbVM = 0;
	nbThreadAELX = 0;
	
	sem_init(&semH, 0, 1);
	sem_init(&semQ, 0, 1);
	sem_init(&semnbVM, 0, 1);
	sem_init(&semConsole, 0, 1);
	sem_init(&semnbThreadAELX, 0, 1);
	sem_init(&semAdd, 0, 1);
	sem_init(&semRemove, 0, 1);
	sem_init(&semListPtr, 0, 1);
	sem_init(&semExecutePtr, 0, 1);
	

	//"Nettoyage" de la fenêtre console
	//cls();
	printf("\n==============DEBUT DES TRANSACTIONS===============\n\n");
	
	readTrans(argv[1]);
	
	printf("\n===============FIN DES TRANSACTIONS================\n\n");
	
	
	sem_destroy(&semH);
	sem_destroy(&semQ);
	sem_destroy(&semnbVM);
	sem_destroy(&semConsole);
	sem_destroy(&semnbThreadAELX);
	sem_destroy(&semAdd);
	sem_destroy(&semRemove);
	sem_destroy(&semListPtr);
	sem_destroy(&semExecutePtr);

	/*free(head);
	free(queue);
	free(listPtr);
	free(executePtr);	*/


	//Fin du programme
	exit( 0);
}

