#include "server.h"
#include "gestionListeChaineeVMS.h"
/*
s'appellait main avant que j'essait de faire reconnaitre main par gcc ce
qui n'a pas marcher plus
*/
int mainloop(){
    console = 0;
    head = NULL;
    queue = NULL;
    nbVM = 0;
    nbTh = 0;
    startQ = 0;

    int fd = -1;
    int res;
    bool endLoop = 1;
    res = mkfifo(ServerFifoN,0777);
    if(res != 0){ //fifo didn't create
        printf("Fifo server couldnt be created");
        exit(EXIT_FAILURE);
    }

    while(endLoop){
        fd = open(ServerFifoN,O_RDONLY);
        if(fd != -1){
            //FIFO has something
            close(fd);
            if(readTrans(ServerFifoN)){
                endLoop = 0;//ferme la boucle
            }
        }
        close(fd);
        //attend la prochaine transaction
        sleep(200);
    }

    //attend que tous les threads aille terminer avant la fermeture du server
    if(nbTh==25) nbTh = 24;
    for (int i=0;i==nbTh;i++){
        pthread_join(Safe[i],NULL);
    }
    unlink(ServerFifoN);
    return 0;

}
/*Gere les treads de manieres a ce que les plus vieux treads soit detacher apres que la liste soit pleine*/
int threaderMonster(void *Fonction, void *varpg){
    if (nbTh == 0){//premier thread
        startQ++;
        pthread_create(&Safe[nbTh],NULL,Fonction,varpg);
        nbTh++;
        return 0;
    }
    if (nbTh == 25){
        /*Capaciter maximale atteinte*/
        if(startQ == 25){
            startQ = 0; //reset loop au travers safe
        }
        pthread_detach(Safe[startQ]);//ideallement aurait fini leurs executions
        pthread_create(&Safe[startQ],NULL,Fonction,varpg);
        startQ++;

    }else{
        /*moin que la capaciter de Safe*/
        pthread_create(&Safe[nbTh],NULL,Fonction,varpg);
        nbTh++;
        startQ++;
    }

    return 0;
}

/*Lit les donnes de transaction passer au travers de la fifo*/
int readTrans(char nomFichier){
    int f,g,c;
    char tok, *sp;
    char cFifo[256];
    struct Info_FIFO_Transaction trans;
    f = open(nomFichier, O_RDONLY);

    do{//boucle qui fait les donnes dans la Fifo
        struct Feedback feed;
        g = read(f,&trans,sizeof(trans));
        if(g > 0){
            sprintf(cFifo,ClientFifoN,trans.pid_clients);
            c = open(cFifo,O_WRONLY);
            tok = trans.transaction[0];
            switch(tok){
                case 'A':
                case 'a':{


                    threaderMonster(addItem(),NULL);
                    feed.isgood = 1;
                    write(c,&feed,sizeof(feed));
                    break;
                }
                case 'E':
                case 'e':{
                    int noVM = atoi(strtok_r(NULL, " ", &sp));

                    threaderMonster(removeItem,(void*)noVM);
                    feed.isgood = 1;
                    write(c,&feed,sizeof(feed));
                    break;
                }
                case 'L':
                case 'l':{
                    struct pass *a;
                    a->start = atoi(strtok_r(NULL, "-", &sp));
                    a->end = atoi(strtok_r(NULL, " ", &sp));

                    threaderMonster(listItems,(void*)a);
                    feed.isgood = 1;
                    write(c,&feed,sizeof(feed));
                    break;
                }
                case 'X':
                case 'x':{
                    struct passby *a;
                    a->noVM = atoi(strtok_r(NULL, " ", &sp));
                    a->nomFich= strtok_r(NULL, "/n", &sp);

                    threaderMonster(executeFile,(void*)a);
                    feed.isgood = 1;
                    write(c,&feed,sizeof(feed));
                    break;
                }
                /*Ferme le serveur*/
                case 'Q':
                case 'q':{
                    feed.isgood = 1;
                    write(c,&feed,sizeof(feed));
                    return 1;
                }
            }
        close(c);
        }
    }while(g > 0);
    close(f);


    return 0;

}


void cls(void){
    printf("    ");
}

void error(const int exitcode, const char * message){
    printf("/n%s",message);
    exit(exitcode);
}

uint16_t sign_extent(uint16_t x, int bit_count){
    if ((x >> (bit_count -1)) & 1){
        x |= (0xFFFF << bit_count);
    }
    return x;
}

uint16_t swap16(uint16_t x){
    return (x<<8)|(x>>8);
}

void update_flags(uint16_t reg[R_COUNT], uint16_t r){
    if (reg[r] == 0){
        reg[R_COND] = FL_ZRO;
    }
    else if (reg[r]>>15){
        reg[R_COND] = FL_NEG;
    }
    else{
        reg[R_COND] = FL_POS;
    }
}

int read_image_file(uint16_t * memory,char* image_path,uint16_t * origin,struct noeudVM * ptr){
    char fich[200];
    strcpy(fich,image_path);
    FILE* file = fopen(fich,"rb");

    if (!file){return 0;}

    *origin=0x3000;

    uint16_t max_read = UINT16_MAX - *origin;
    uint16_t* p = memory + *origin;
    ptr->VM.offsetDebutCode = *origin;
    size_t read = fread(p, sizeof(uint16_t), max_read, file);
    ptr->VM.offsetFinCode = *origin+read-1;

    while(read-- > 0){
        ++p;

    }
    return 1;
}

uint16_t check_key(){
    fd_set readfds;
    FD_ZERO(&readfds);
    FD_SET(STDIN_FILENO, &readfds);

    struct timeval timeout;
    timeout.tv_sec = 0;
    timeout.tv_usec = 0;
    return select(1, &readfds, NULL, NULL, &timeout) != 0;
}

void mem_write(uint16_t * memory, uint16_t address, uint16_t val){
    memory[address] =val;
}

uint16_t mem_read(uint16_t * memory, uint16_t address){
     if (address == MR_KBSR){
        if (check_key()){
            memory[MR_KBSR] = (1<<15);
            memory[MR_KBDR] = getchar();
        }
        else{
            memory[MR_KBSR] = 0;
        }
    }
    return memory[address];
}

struct termios original_tio;

void disable_input_buffering(){
    tcgetattr(STDIN_FILENO,&original_tio);
    struct termios new_tio = original_tio;
    new_tio.c_lflag &= ICANON & ~ECHO;
    tcsetattr(STDIN_FILENO, TCSANOW, &new_tio);
}

void restore_input_buffering(){
    tcsetattr(STDIN_FILENO, TCSANOW, &original_tio);
}

void handle_interrupt(int signal){
    restore_input_buffering();
    exit(-2);
}

int executeFile(int noVM, char* sourcefname){
    uint16_t * memory;
    uint16_t origin, PC_START;

    uint16_t reg[R_COUNT];

    struct noeudVM* ptr = findItem(noVM); //ptr is busy

    if(ptr == NULL){
        printf("VM is NULL\n");
        return(0);
    }
    memory = ptr->VM.ptrDebutVM;

    if(!read_image_file(memory, sourcefname, &origin, ptr)){
        printf("Image didn\'t load properly");
        return(0);
    }

    while(ptr->VM.busy !=0){} //wait for VM available
    ptr->VM.busy = 1;

    signal(SIGINT, handle_interrupt);
    disable_input_buffering();

    PC_START = origin;
    reg[R_PC] = PC_START;
    uint16_t instr, op;

    int running = 1;

    while(running){

        if(validAdress(memory, reg[R_PC], ptr, 'R')){
            instr = mem_read(memory, reg[R_PC]++);
        }
        else{
            running = 0;
            printf("memory problem");
            continue;
        }
        op = instr >> 12;
        switch(op){
            case OP_ADD:{
                uint16_t r0 = (instr >> 9) & 0x7;
                uint16_t r1 = (instr >> 6) & 0x7;
                uint16_t imm_flag = (instr >>5) & 0x1;

                if (imm_flag){
                    uint16_t imm5 = sign_extent(instr & 0x1F,5);
                    reg[r0] = reg[r1] + imm5;
                }
                else{
                    uint16_t r2 = instr & 0x7;
                    reg[r0] = reg[r1] + reg[r2];
                    printf("\n add reg[0] (sum) = %d",reg[r0]);
                }
                update_flags(reg, r0);
            }
            break;
            case OP_AND:{
                 uint16_t r0 = (instr >> 9) & 0x7;
                 uint16_t r1 = (instr >> 6) & 0x7;
                 uint16_t imm_flag = (instr >>5) & 0x1;

                 if (imm_flag){
                    uint16_t imm5 = sign_extent(instr & 0x1F,5);
                    reg[r0] = reg[r1] + imm5;
                 }
                 else{
                     uint16_t r2 = instr & 0x7;
                    reg[r0] = reg[r1] & reg[r2];
                 }
                 update_flags(reg, r0);
            }
            break;
            case OP_NOT:{
                uint16_t r0 = (instr >> 9) & 0x7;
                uint16_t r1 = (instr >> 6) & 0x7;

                reg[0] = ~reg[r1];
                update_flags(reg,r0);
            }
            break;
            case OP_BR:{
                uint16_t pc_offset = sign_extent(instr & 0x1FF, 9);
                uint16_t cond_flag = (instr >> 9) & 0x7;

                if(cond_flag & reg[R_COND]){
                    reg[R_PC] += pc_offset;
                }
            }
            break;
            case OP_JMP:{
                uint16_t r1 = (instr >> 6) & 0x7;
                reg[R_PC] = reg[r1];
            }
            break;
            case OP_JSR:{
                uint16_t long_flag = (instr >> 11) & 1;
                reg[R_R7] = reg[R_PC];
                if (long_flag){
                    uint16_t long_pc_offset = sign_extent(instr & 0x7FF, 11);
                    reg[R_PC] += long_pc_offset;
                }
                else{
                    uint16_t r1 = (instr >> 6) & 0x7;
                    reg[R_PC] = reg[r1];
                }

            }
            break;
            case OP_LD:{
                uint16_t r0 = (instr >> 9) & 0x7;
                uint16_t pc_offset = sign_extent(instr & 0x1FF, 9);
                if(validAdress(memory,reg[R_PC] + pc_offset, ptr, 'R')){
                    reg[r0] = mem_read(memory, reg[R_PC] + pc_offset);
                    update_flags(reg,r0);
                }
                else{
                    running = 0;
                    printf("memory OOB");
                }
            }
            break;
            case OP_LDI:{
                uint16_t r0 = (instr >> 9) & 0x7;
                uint16_t pc_offset = sign_extent(instr & 0x1FF, 9);
                if(validAdress(memory,reg[R_PC] + pc_offset, ptr, 'R')){
                    reg[r0] = mem_read(memory, mem_read(memory, reg[R_PC] + pc_offset));
                    update_flags(reg,r0);
                }
                else{
                    running = 0;
                    printf("memory OOB");
                }
            }
            break;
            case OP_LDR:{
                uint16_t r0 = (instr >> 9) & 0x7;
                uint16_t r1 = (instr >> 6) & 0x7;
                uint16_t offset = sign_extent(instr & 0x3F, 6);
                if(validAdress(memory,reg[r1] + offset, ptr, 'R')){
                    reg[0] = mem_read(memory, reg[r1]+offset);
                    update_flags(reg,r0);
                }
                else{
                    running = 0;
                    printf("memory OOB");
                }
            }
            break;
            case OP_LEA:{
                uint16_t r0 = (instr >> 9) & 0x7;
                uint16_t pc_offset = sign_extent(instr & 0x1FF, 9);
                reg[r0] = reg[R_PC] + pc_offset;
                update_flags(reg,r0);
            }
            break;
            case OP_ST:{
                uint16_t r0 = (instr >> 9) & 0x7;
                uint16_t pc_offset = sign_extent(instr & 0x1FF, 9);
                if(validAdress(memory,reg[R_PC] + pc_offset, ptr, 'W')){
                    mem_write(memory,reg[R_PC]+pc_offset,reg[r0]);
                }
                else{
                    running = 0;
                    printf("memory OOB or access violation");
                }
            }
            break;
            case OP_STI:{
                uint16_t r0 = (instr >> 9) & 0x7;
                uint16_t pc_offset = sign_extent(instr & 0x1FF, 9);
                if(validAdress(memory,reg[R_PC] + pc_offset, ptr, 'R')){
                    if(validAdress(memory,reg[R_PC] + pc_offset, ptr, 'W')){
                    mem_write(memory,reg[R_PC]+pc_offset,reg[r0]);
                    }
                    else{
                        running = 0;
                        printf("memory OOB or access violation");
                    }
                }
                else{
                    running = 0;
                    printf("memory OOB");
                }

            }
            break;
            case OP_TRAP:{
                switch (instr & 0xFF){
                    case TRAP_GETC: reg[R_R0] = (uint16_t)getchar(); break;
                    case TRAP_OUT:{
                        putc((char)reg[R_R0], stdout);
                        fflush(stdout);
                    }break;
                    case TRAP_PUTS:{
                        uint16_t* c = memory + reg[R_R0];
                        if(validAdress(c, 0, ptr,'R')){
                            while(*c){
                                putc((char)*c, stdout);
                                ++c;
                                if (!validAdress(c, 0, ptr,'R')){
                                    running = 0;
                                    printf("memory oob");
                                    *c = 0;
                                   }
                            }
                            fflush(stdout);
                        }
                        else{
                            running = 0;
                            printf("memory oob");
                        }
                    }break;
                    case TRAP_IN:{
                        printf("Enter a character: ");
                        char c = getchar();
                        putc(c,stdout);
                        reg[R_R0] = (uint16_t)c;
                    }break;
                    case TRAP_PUTSP:{
                        uint16_t* c = memory + reg[R_R0];
                        if(validAdress(c, 0, ptr, 'R')){
                            while(*c){
                                char char1 = (*c) & 0xFF;
                                putc(char1,stdout);
                                char char2 = (*c) >> 8;

                                if (char2) putc(char2, stdout);
                                ++c;
                                if (!validAdress(c, 0, ptr, 'R')){
                                    running = 0;
                                    printf("memory oob");
                                    *c = 0;
                                }
                            }
                            fflush(stdout);
                        }
                        else{
                            running = 0;
                            printf("memory oob");
                        }
                    }break;
                    case TRAP_HALT:{
                        puts("/nHALT");
                        fflush(stdout);
                        running = 0;
                    }break;
                }
            }
            break;
            case OP_RES:
            case OP_RTI:
            default:abort();break;
        }
    }
    ptr->VM.busy = 0;
    restore_input_buffering();
    return(1);
}



int validAdress(uint16_t * memory, uint16_t offset, struct noeudVM * ptr, char accessType){
    if ( ((memory + offset)>(memory+65535)) || ((memory)>(memory+offset)) ){
        printf("wrong adress");
        return 0;
    }
    if (accessType == 'W'){
        if (((memory+offset)>(memory+ptr->VM.offsetDebutCode)) && ((memory+ptr->VM.offsetFinCode)>(memory+offset))){
            printf("\n invalid address in writing mode");
            return 0;
        }
    }
    return 1;
}




