#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <semaphore.h>
#include <pthread.h>

#include <stdint.h>
#include <signal.h>
/* unix */
#include <unistd.h>
#include <fcntl.h>

#include <sys/time.h>
#include <sys/types.h>
#include <sys/termios.h>
#include <sys/mman.h>

struct infoVM{						
	int		noVM;
	unsigned char 	busy; 
	unsigned short * 	ptrDebutVM;							
	};								 

struct noeudVM{			
	struct infoVM	VM;		
	struct noeudVM		*suivant;	
	// Semaphore pour chaque noeud VM
	sem_t semNoeud;
	};	

//la structure pour le passage des parametres au thread executeFile()
struct paramX{
	int noVM;
	char nomfich[100];
	struct info_FIFO_Transaction* trans;
	};

//la structure pour le passage des parametres au thread listItem()
struct paramL{
	int nstart;
	int nend;
	struct info_FIFO_Transaction* trans;
	};

	
void cls(void);
void error(const int exitcode, const char * message);

struct noeudVM * findItem(const int no);
struct noeudVM * findPrev(const int no);

void addItem();
void removeItem(const int noVM);
void listItems(struct paramL* param);
void executeFile(struct paramX* param);

void* readTrans(void* arg);