#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <string.h>
#include <semaphore.h>
#include <pthread.h>
#include <curses.h>
#include <fcntl.h>
#include <sys/stat.h>

#define SERVER_FIFO_NAME "../Server/tmp/FIFO_TRANSACTIONS"
#define CLIENT_FIFO_NAME "./tmp/FIFO%d"

struct AppWindows {
	WINDOW *transmission_window_ptr;
	WINDOW *reception_window_ptr;
};

struct Info_FIFO_Transaction {
	int pid_client;
	char transaction[399];
};

void initializeWindows();
void verifyColorSupport();
void startServerHandler();
void readServerResult();
void initializeFIFO();
void readCommand();
void processCommand();
void printInstructions();
void printInfoSent();
void printServerResponse(struct Info_FIFO_Transaction response);
void openServerFifo();
