#include "client.h"
#include "gestionListeChaineeVMS.h"
#include <ctype.h>

int main()
{
    int fifo_transaction_fd, client_fifo_fd;
    struct Info_FIFO_Transaction transaction;    
    char client_fifo[100];   	
    WINDOW *new_window_ptr;
    WINDOW *popup_window_ptr; 
    int iterx;
    int itery;
    char lettre_a = '*'; 
    int i;
    //Pour initialiser une  fenetre  par defaut
    initscr();   
   
    fifo_transaction_fd = open(FIFO_TRANSACTIONS, O_WRONLY);//Overture de la fifo On Write only
    

    if (fifo_transaction_fd == -1) {
        fprintf(stderr, "Error-No server found \n");
        exit(EXIT_FAILURE);
    }
    transaction.pid_client = getpid();//Donc on commence par recuperer le pid
    sprintf(client_fifo, CLIENT_FIFO_NAME, transaction.pid_client);

    if (mkfifo(client_fifo, 0777) == -1) {
        fprintf(stderr, "Sorry, can't make %s\n", client_fifo);
        exit(EXIT_FAILURE);
    }
    if (!has_colors()) {//(initialise table's colors)
        endwin();
        fprintf(stderr, "Eror couleur non supporté par le terminal \n");
        exit(1);
    }
//Verifier si la couleur fonctionne sur le terminal
    if (start_color() != OK) {
        endwin();
        fprintf(stderr, "Erreur - Couleur non initialisé \n");
        exit(2);
    }


    clear();//Nettoyage console

    init_pair(1, COLOR_WHITE, COLOR_BLACK);    //l'entre 1 sera blanc sur noir
  
    init_pair(3, COLOR_RED, COLOR_GREEN);//l'entre 3 sera rouge sur vert

    attrset(COLOR_PAIR(3));
    
    refresh();
       
    for (iterx = 0; iterx < COLS - 1; iterx++) {
        for (itery = 0; itery < LINES - 14; itery++) {
            mvwaddch(stdscr, itery, iterx, lettre_a);            
        }
    }

  
      
    for (iterx = 0; iterx < COLS - 1; iterx++) {
        for(itery = 15; itery < LINES -1; itery++) {
            mvwaddch(stdscr, itery, iterx, lettre_a);           
        }
    }

    refresh();
    attrset(COLOR_PAIR(1));
    refresh();


   do{        
        bzero(transaction.transaction, strlen(transaction.transaction));               
      
        move(5, 5);
       
        new_window_ptr = newwin(10, 120, 2, 2);
        mvwprintw(new_window_ptr, 0, 1, "%s", "=====================================================================\n");
        mvwprintw(new_window_ptr, 1, 1, "%s", "                              TRANSMISSION                           \n"); 
        mvwprintw(new_window_ptr, 2, 1, "%s", "=====================================================================\n");
        mvwprintw(new_window_ptr, 4, 2, "%s", "Enter une nouvelle transaction ou ecrivez 'q' ou 'quit' pour quiter : \n");

        refresh(); 
        wrefresh(new_window_ptr);          
        
        move(7,4);
      
        getstr(transaction.transaction);//recuperer lentree  de l'utilisateur et l'Enregistrer        
       
        if(transaction.transaction[0] != 'q' && transaction.transaction[0] != 'Q')//Si l'user ne quite pas 
        																									  //Ce qui veut dire qu'il envoye une [transaction]
        { 
            write(fifo_transaction_fd, &transaction, sizeof(transaction));//renvoie  l'input au serveur
            
            client_fifo_fd = open(client_fifo, O_RDONLY);  //Ouvrir la fifo de reception, pour avoir le resultat de ce que le serveur a retourner
            
            if (client_fifo_fd != -1) //succes de l'ouverture ou echec(-1) 
            {
                if (read(client_fifo_fd, &transaction, sizeof(transaction)) > 0) 
                {
                   
                    touchwin(new_window_ptr);
                    wrefresh(new_window_ptr);                    

                    popup_window_ptr = newwin(15, 120, 14, 2);
                  
                    mvwprintw(popup_window_ptr, 0, 1, " ");
                  
                    mvwprintw(popup_window_ptr, 0, 1, "%s", "*********************************************************************\n");
                    mvwprintw(popup_window_ptr, 1, 1, "%s", "                              RECEPTION                              \n"); 
                    mvwprintw(popup_window_ptr, 2, 1, "%s", "*********************************************************************\n");
                    mvwprintw(popup_window_ptr, 4, 2, "%s \n", transaction.transaction);
                    wrefresh(popup_window_ptr);   
                }
                close(client_fifo_fd);//Fermer la fifo de reception apres avoir traite son contenu
            }
        }            
        
    }
    while(transaction.transaction[0] != 'q' && transaction.transaction[0] != 'Q');
    endwin();//fermer la fenetre
    close(fifo_transaction_fd);//fermeture de  la fifo
    unlink(client_fifo);//suppression du fifo

    printf("********************     Fermeture  Client  avec succès   ********************\n");
    exit(EXIT_SUCCESS);
}
