 
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <limits.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <ncurses.h>
#include <ctype.h>

#define FIFO_TRANSACTIONS "./tmp/serv_fifo"         // Chemin du fichier FIFO côté serveur
#define CLIENT_FIFO_NAME "./tmp/cli_%d_fifo"       // Modèle de nom pour les fichiers FIFO côté client

#define BUFFER_SIZE 400

// Structure pour la transmission d'informations via la FIFO, avec un buffer de 400 caractères
struct Info_FIFO_Transaction {
    pid_t  pid_client;                           // PID du client
    char   transaction[BUFFER_SIZE - 1];    // Chaîne de caractères représentant la transaction
};
