
#include <stdio.h>
#include <stdlib.h> // pour la fonction exit()
#include <math.h>

#define MAX_BITS 16

int main() {
    FILE *fp;
    FILE *fpBin;
    int i, c;
    unsigned short sum = 0;

    const char *fichTXT = "trans1.txt";

    fp = fopen(fichTXT, "r");
    if (fp == NULL) {
        perror("Erreur lors de l'ouverture du fichier texte");
        exit(EXIT_FAILURE);
    }

    fpBin = fopen(ficBIN, "wb");
    if (fpBin == NULL) {
        perror("Erreur lors de la cration du fichier binaire");
        fclose(fp);
        exit(EXIT_FAILURE);
    }

    while (1) {
        sum = 0;
        for (i = 0; i < MAX_BITS; i++) {
            c = fgetc(fp);
            if (feof(fp)) {
                break;
            }
            if (c == '0' || c == '1') {
                sum += (c - '0') * pow(2.0, MAX_BITS - 1 - i);
            } else {
                // Gestion d'un caractre non binaire (ignor)
                i--;
            }
        }

        // criture de la somme dans le fichier binaire
        fwrite(&sum, sizeof(unsigned short), 1, fpBin);
    }

    // Fermeture des fichiers
    fclose(fp);
    fclose(fpBin);

    return 0;
}
