#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <semaphore.h>
#include <pthread.h>

#include <stdint.h>
#include <signal.h>
/* unix */
#include <unistd.h>
#include <fcntl.h>

#include <sys/time.h>
#include <sys/types.h>
#include <sys/termios.h>
#include <sys/mman.h>

struct infoVM {
    int noVM;
    unsigned char busy;
    uint16_t *ptrDebutVM;
    uint16_t offsetDebutCode; // region memoire ReadOnly
    uint16_t offsetFinCode;
};

struct noeudVM {
    struct infoVM VM;
    struct noeudVM *suivant;
    sem_t semVM;
};

void cls(void);

void error(const int exitcode, const char *message);

struct noeudVM *findItem(const int no);

struct noeudVM *findPrev(const int no);

// Struc pour threader les transactions
struct paramA
{
    int pidClient;
};


struct paramE {
    int noVM;
    int pidClient;
};

struct paramX {
    int noVM;
    char nomFichier[100];
    int pidClient;
};

struct paramL {
    int startVMNo;
    int endVMNo;
    int pidClient;
};

void *addItem(void *param);

void *removeItem(void *param);

void *listItems(void *param);

void saveItems(const char *sourcefname);

void *executeFile(void *param);

void readTrans();


