#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <pthread.h>

#define RESPONSE_FIFO_SIZE 100
#define BUFFER_SIZE 400
#define TRANSACTION_FIFO "./FIFO_TRANSACTION"

struct Info_FIFO_Client_Feedback {
int		fifo_transaction_fd, client_fifo_fd;
char	client_fifo[1000];
};

struct Info_FIFO_Transaction {
	int  		pid_client;
	char 		transaction[200];
};

// Function prototype for write_to_fifo_thread
void* write_to_fifo_thread(struct Info_FIFO_Transaction* args);

// Function definition / signature to create client's FIFO
void create_client_fifo(char *fifo_name, pid_t pid);

// Function definition / signature to write to the transaction FIFO
void write_to_fifo(int client_pid, const char *transaction);

// Function definition / signature to read from the client's FIFO
struct Info_FIFO_Client_Feedback read_from_fifo(const char *fifo_name);
