//#########################################################
//#
//# Titre : 	        TP1
//# Auteur : 	        Simon Lavgine 
//# Auteur original : 	Francois Meunier
//#	Date :		        10-31-2023
//#
//#######################################

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pthread.h>
#include <unistd.h>
#include <limits.h>
#include <fcntl.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/termios.h>
#include <sys/mman.h>

//Struct for passing parameters to the thread to the ExecuteFile function
struct paramExecute{
	int noVM;
	char nomfich[100];
	int pid_client;
	
	};
	
//Struct for passing parameters to the thread to the RemoveItem function
struct paramRemove{
	int noVM;
	};

//Struct for passing parameters to the thread to the ListItems function
struct paramList{
	int nstart;
	int nend;
	int pid_client;
	
	};

struct infoVM{						
	int		noVM;
	unsigned char 	busy; 
	unsigned short * 	ptrDebutVM;							
	};								 

struct noeudVM{			
	struct infoVM	VM;		
	struct noeudVM		*suivant;	
	pthread_mutex_t mutexNode;
};	

struct Info_FIFO_Client_Feedback {
int		fifo_transaction_fd, client_fifo_fd;
char	client_fifo[1000];

};

void cls(void);
void error(const int exitcode, const char * message);
struct noeudVM * findItem(const int no);
void addItem(void * param);
void removeItem(struct paramRemove* param);
void listItems(struct paramList* param);
void executeFile(struct paramExecute* param);

