#include <pthread.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <stdbool.h>
#include <fcntl.h>
#define ServerFifoN "/tmp/serv_fifo"
#define ClientFifoN "/tmp/cli_%d_fifo"



struct Feedback{ //pourrait etre plus gros mais pour le present exemple pas besoin
    int isgood;
};

struct Info_FIFO_Transaction{
    int pid_clients;
    char transaction[200];
};
struct noeudVM* head;
struct noeudVM* queue;
int nbVM, console, startQ, nbTh;

int mainloop();
int threaderMonster(void* Fonction,void* varpg);

struct pass{
    int end;
    int start;
};

struct passby{
    int noVM;
    char* nomFich;
};
enum{
    R_R0 = 0,
    R_R1,
    R_R2,
    R_R3,
    R_R4,
    R_R5,
    R_R6,
    R_R7,
    R_PC,
    R_COND,
    R_COUNT
};

enum{
    OP_BR = 0,
    OP_ADD,
    OP_LD,
    OP_ST,
    OP_JSR,
    OP_AND,
    OP_LDR,
    OP_STR,
    OP_RTI,
    OP_NOT,
    OP_LDI,
    OP_STI,
    OP_JMP,
    OP_RES,
    OP_LEA,
    OP_TRAP
};

enum{
    FL_POS = 1 << 0,
    FL_ZRO = 1 << 1,
    FL_NEG = 1 << 2,
};
enum{
    MR_KBSR = 0xFE00,
    MR_KBDR = 0xFE02,
};
enum{
    TRAP_GETC = 0x20,
    TRAP_OUT = 0x21,
    TRAP_PUTS = 0x22,
    TRAP_IN = 0x23,
    TRAP_PUTSP = 0x24,
    TRAP_HALT = 0x25
};

uint16_t sign_extent(uint16_t x, int bit_count);
uint16_t swap16(uint16_t x);
void update_flags(uint16_t reg[R_COUNT], uint16_t r);
int read_image_file(uint16_t * memory,char* image_path,uint16_t * origin,struct noeudVM * ptr);
int validAdress(uint16_t * memory,uint16_t offset, struct noeudVM * ptr, char accessType);
uint16_t check_key();
void mem_write(uint16_t * memory, uint16_t address, uint16_t val);
uint16_t mem_read(uint16_t * memory, uint16_t address);

void disable_input_buffering();
void restore_input_buffering();

void handle_interrupt(int signal);


pthread_t Safe[25];


